
#include "Arduino.h"
#include "nokia_b.h"
#include "EEPROM.h"

int PIN_SCE;
int PIN_RESET;
int PIN_DC;
int PIN_SDIN;
int PIN_SCLK;

int PIN_PODSV;

int bignum;
int midnum;

int x_rad;
int x_poloha;

byte mabzuknouterr;



nokia_b::nokia_b(int rst, int ce, int dc, int in, int clk, int podsv)
{
      #define LCD_C     LOW
      #define LCD_D     HIGH
      #define LCD_CMD   0

      // velikost LCD
      #define LCD_X     84
      #define LCD_Y     48

      PIN_SCE = ce;
      PIN_RESET = rst;
      PIN_DC = dc;
      PIN_SDIN = in;
      PIN_SCLK = clk;


      PIN_PODSV = podsv;

}

void nokia_b::bajt_7C(void)
{
  LcdWrite(LCD_D, 0x7C);
}

void nokia_b::bajt_7F(void)
{
  LcdWrite(LCD_D, 0x7F);
}



void nokia_b::ramecek(int ala_count, int zaz_count, int mem_proc , boolean inv )
 {

   GotoXY(0,3);          // zobrazeni hlavicky v inforamecku:  |A| Z |M|
   for (int index = 0; index < 49; index++)
     {
       LcdWrite(LCD_D, EEPROM.read(410 + index));
     }

   if (inv == true)
     {
       GotoXY(35,3);             // inverzni pismeno M (bile na cernem podklade)
       bajt_7C();
       bajt_7C();
       bajt_7C();
       LcdWrite(LCD_D, 0x44);
       LcdWrite(LCD_D, 0x74);
       LcdWrite(LCD_D, 0x6C);
       LcdWrite(LCD_D, 0x5C);
       LcdWrite(LCD_D, 0x6C);
       LcdWrite(LCD_D, 0x74);
       LcdWrite(LCD_D, 0x44);
       bajt_7C();
       bajt_7C();
       bajt_7C();


     }

   GotoXY(0,4);               // spodni svisle cary v inforamecku
   bajt_7F();                 // cara pred A
   GotoXY(14,4);
   bajt_7F();                 // cara mezi A a Z
   GotoXY(34,4);
   bajt_7F();                 // cara mezi Z a M
   GotoXY(48,4);
   bajt_7F();                 // cara za M


  GotoXY(1, 4);
  LcdNum(ala_count, 2, ' ');



  GotoXY(15, 4);
  LcdNum(zaz_count, 3, ' ');





  GotoXY(35, 4);
  if (mem_proc < 100)
    {
      LcdNum(mem_proc, 2, ' ');
      mabzuknouterr = 1;
    }
  else if(mem_proc == 211)
    {
      LcdString("--");
      if (mabzuknouterr == 1)
        {
          tone(A2, 2000, 300);
          mabzuknouterr = 0;

        }
    }
  else if(mem_proc == 233)
    {
      LcdString("FF");
    }

 }




 void nokia_b::podsvet(byte uroven)
 {

   analogWrite(PIN_PODSV, 255 - uroven);

 }


 void nokia_b::dvojtecka(void)
 {
   GotoXY(40,0);
   for (int index = 0; index < 4; index++)
     {
       LcdWrite(LCD_D, 0xE0);
     }
   GotoXY(40,1);
   for (int index = 0; index < 4; index++)
     {
       LcdWrite(LCD_D, 0xC3);
     }
   GotoXY(40,2);
   for (int index = 0; index < 4; index++)
     {
       LcdWrite(LCD_D, 0x07);
     }


 }

 void nokia_b::mid7seg(int midnum, int x_rad)
 {

  if (x_rad == 0) {x_poloha = 0;}

  if (x_rad == 1) {x_poloha = 57;}
  if (x_rad == 2) {x_poloha = 72;}

  GotoXY(x_poloha,4);
  for (int index = 0; index < 3; index++)
    {
       LcdWrite(LCD_D, EEPROM.read((midnum*7) + index));
    }
  for (int index = 0; index < 6; index++)
    {
       LcdWrite(LCD_D, EEPROM.read((midnum*7) + 3));
    }
  for (int index = 0; index < 3; index++)
    {
       LcdWrite(LCD_D, EEPROM.read((midnum*7) + index + 4));
    }


  GotoXY(x_poloha,5);

  for (int index = 0; index < 3; index++)
    {
       LcdWrite(LCD_D, EEPROM.read((midnum*7) + index + 70));
    }
  for (int index = 0; index < 6; index++)
    {
       LcdWrite(LCD_D, EEPROM.read((midnum*7) + 73));
    }
  for (int index = 0; index < 3; index++)
    {
       LcdWrite(LCD_D, EEPROM.read((midnum*7) + index + 74));
    }




 }



 void nokia_b::big7seg(char character2, int x_rad)
 {

  // prevadi rad velkych znaku 1 az 4 na polohu na displeji v pixelech

  if (x_rad == 1) x_poloha = 0;
  if (x_rad == 2) x_poloha = 20;
  if (x_rad == 3) x_poloha = 47;
  if (x_rad == 4) x_poloha = 67;

  if (character2 == ' ')
    {
        GotoXY(x_poloha,0);
        for (int index = 0; index < 17; index++)
          {
             LcdWrite(LCD_D, 0);
          }
        GotoXY(x_poloha,1);
        for (int index = 0; index < 17; index++)
          {
             LcdWrite(LCD_D, 0);
          }
        GotoXY(x_poloha,2);
        for (int index = 0; index < 17; index++)
          {
             LcdWrite(LCD_D, 0);
          }

    }
  else
   {

      int bignum = character2 - '0';


      GotoXY(x_poloha,0);
      for (int index = 0; index < 4; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(140 + (bignum*9) + index));
        }
      for (int index = 0; index < 9; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(140 + (bignum*9) + 4));
        }
      for (int index = 0; index < 4; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(140 + (bignum*9) + index + 5));
        }



      GotoXY(x_poloha,1);
      for (int index = 0; index < 4; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(230 + (bignum*9) + index));
        }
      for (int index = 0; index < 9; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(230 + (bignum*9) + 4));
        }
      for (int index = 0; index < 4; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(230 + (bignum*9) + index + 5));
        }



      GotoXY(x_poloha,2);
      for (int index = 0; index < 4; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(320 + (bignum*9) + index));
        }
      for (int index = 0; index < 9; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(320 + (bignum*9) + 4));
        }
      for (int index = 0; index < 4; index++)
        {
           LcdWrite(LCD_D, EEPROM.read(320 + (bignum*9) + index + 5));
        }



    }




 }




void nokia_b::LcdKod(byte kod)
{
    LcdWrite(LCD_D, 0x00);
    for (int index = 0; index < 5; index++)
      {
        LcdWrite(LCD_D, EEPROM.read(460 + ((kod - 0x20) * 5) + index));
      }
}


void nokia_b::LcdCharacter(char character)
{
  LcdWrite(LCD_D, 0x00);
  for (int index = 0; index < 5; index++)
    {
      LcdWrite(LCD_D, EEPROM.read(460 + ((character - 0x20) * 5) + index));
    }

}

void nokia_b::LcdClear(void)
{

  for (int index = 0; index < LCD_X * LCD_Y / 8; index++)
  {
    LcdWrite(LCD_D, 0x00);
  }
}


void nokia_b::LcdString(char* characters)
{



  while (*characters)
  {
  LcdCharacter(*characters++);
  }




}






void nokia_b::LcdBig(char* characters2, int x_rad)
{
   while (*characters2)
  {
  big7seg(*characters2++ , x_rad);
  }
}



void nokia_b::LcdWrite(byte dc, byte data)
{
  digitalWrite(PIN_DC, dc);
  digitalWrite(PIN_SCE, LOW);
  shiftOut(PIN_SDIN, PIN_SCLK, MSBFIRST, data);
  digitalWrite(PIN_SCE, HIGH);
}


void nokia_b::LcdInitialise(byte vopbajt, byte tempbajt, byte biasbajt)
{
  pinMode(PIN_SCE,   OUTPUT);
  pinMode(PIN_RESET, OUTPUT);
  pinMode(PIN_DC,    OUTPUT);
  pinMode(PIN_SDIN,  OUTPUT);
  pinMode(PIN_SCLK,  OUTPUT);

  digitalWrite(PIN_RESET, LOW);
  delay(100);
  digitalWrite(PIN_RESET, HIGH);
  delay(100);

  if (tempbajt > 7 || tempbajt <4 || biasbajt > 23 || biasbajt < 16 || vopbajt < 128 )
    {
       tempbajt = 4;
       biasbajt = 17;
       vopbajt = 205;
    }








  LcdWrite(LCD_CMD, 0x21);  // LCD Extended Commands.
  LcdWrite(LCD_CMD, vopbajt);  // Set LCD Vop (Contrast). //B1
  LcdWrite(LCD_CMD, tempbajt);  // Set Temp coefficent. //0x04
  LcdWrite(LCD_CMD, biasbajt);  // LCD bias mode 1:48. //0x13
  LcdWrite(LCD_CMD, 0x0c);  // LCD in normal mode. 0x0d for inverse
  LcdWrite(LCD_C, 0x20);
  LcdWrite(LCD_C, 0x0C);
}

void nokia_b::GotoXY(int x, int y) {

  LcdWrite( 0, 0x80 | x);  // Column.
  LcdWrite( 0, 0x40 | y);  // Row.

}



void nokia_b::LcdNum(unsigned long cislo, int rady, char nuly)
{

  int i;
  int x;
  unsigned long cela_cast;
  unsigned long exponent;
  boolean zacatek = true;

  if (rady == 1)
    {
      LcdKod((int)cislo + 48);
    }
  else
    {
      for (i = rady ; i>0 ; i--)
        {
          exponent = 1;
          for (x=0;x < i-1 ; x++)
            {
              exponent = 10ul * exponent;
            }
          cela_cast = (unsigned long)cislo / exponent;
          if (cela_cast == 0 && zacatek == true && i > 1)
            {
              LcdKod(nuly);
            }
          else
            {
              zacatek = false;
              LcdKod(cela_cast + 48);
            }
          cislo = cislo - (cela_cast * exponent);

        }

    }


}





void nokia_b::LcdNum2(float cislo, int cely, int desetinny)
{
  byte i;
  char cislo_znaky[8];

  byte pridej = 2;
  if (cislo<0) pridej = 3;

  dtostrf(cislo, cely + desetinny , desetinny, cislo_znaky);
  for (i=0;i< cely + desetinny + pridej-1;i++)
    {
      if (cislo_znaky[i] != 0)
        {
          LcdKod(cislo_znaky[i]);
        }
    }

}






